unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Psock, NMHttp, FileCtrl;

type
  THTTPThread = class(TThread)
  private
     {   -    TNMHTTP}
    FHTTP: TNMHTTP;
  protected
     {Execute    ; override -      TThread}
    procedure Execute; override;
     {DoWork -   ,     Execute}
    procedure DoWork;
  public
     {URL -   ,  ,  URL   }
    URL: string;
  end;
  TForm1 = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
  var s: string;
begin
  { URL  }
  s := InputBox('',' URL:','');
  if s <> '' then
    ListBox1.Items.Add(s);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  {  URL  }
  if ListBox1.ItemIndex >= 0 then
    ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TForm1.Button1Click(Sender: TObject);
  var i: Integer;
begin
  {   }
  if Length(Edit1.Text) > 0 then
    if not DirectoryExists(Edit1.Text) then
      MkDir(Edit1.Text);
  {     URL    }
  for i := 0 to ListBox1.Items.Count-1 do begin
    with THTTPThread.Create(True) do begin
      {  ,    URL   }
      URL := ListBox1.Items[i];
      Resume;
    end;
  end;
end;

{  THTTPThread}

procedure THTTPThread.Execute;
begin
  { ,        ()}
  Synchronize(DoWork);
end;

procedure THTTPThread.DoWork;
  var i: Integer;
begin
  {  TNMHTTP}
  FHTTP := TNMHTTP.Create(Form1);
  {    }
  FHTTP.InputFileMode := True;
  {   }
  i := 1;
  while FileExists(Form1.Edit1.Text+'\page'+IntToStr(i)+'.htm') do
    Inc(i);
  {,      }
  FHTTP.Body := Form1.Edit1.Text+'\body'+IntToStr(i)+'.htm';
  FHTTP.Header := Form1.Edit1.Text+'\header'+IntToStr(i)+'.txt';
  {  }
  FHTTP.Get(URL);
  {       - }
  FHTTP.Free;
end;

end.
